#include <stdio.h>
#include <stdlib.h>

#include <g3dviewer_plugin.h>

FILE *g3d_iff_open(const char *filename, guint32 *id, guint32 *len)
{
  FILE *f = fopen(filename, "r");
  guint32 form_bytes;

  if(f == NULL)
  {
    g_warning("can't open file '%s'", filename);
    return NULL;
  }

  if(g3d_read_int32_be(f) != G3D_IFF_MKID('F','O','R','M'))
  {
    g_warning("file %s is not an IFF file", filename);
    fclose(f);
    return NULL;
  }

  form_bytes = g3d_read_int32_be(f);
  *id = g3d_read_int32_be(f);
  form_bytes -= 4;
  *len = form_bytes;

  return f;
}

int g3d_iff_readchunk(FILE *f, guint32 *id, guint32 *len)
{
  *id = g3d_read_int32_be(f);
  *len = g3d_read_int32_be(f);
  return 8 + *len + (*len%2);
}

