
#include <stdio.h>
#include <glib.h>

gint32 g3d_read_int8(FILE *f)
{
	int c = fgetc(f);
	if(c == EOF)
		return 0;
	else
		return c;
}

gint32 g3d_read_int16_be(FILE *f)
{
	return (g3d_read_int8(f)<<8) | g3d_read_int8(f);
}

gint32 g3d_read_int16_le(FILE *f)
{
	return g3d_read_int8(f) | (g3d_read_int8(f)<<8);
}

gint32 g3d_read_int32_be(FILE *f)
{
	return (g3d_read_int8(f) << 24) | (g3d_read_int8(f) << 16) |
		(g3d_read_int8(f) << 8) | g3d_read_int8(f);
}

gint32 g3d_read_int32_le(FILE *f)
{
	return  g3d_read_int8(f) | (g3d_read_int8(f) << 8) |
		(g3d_read_int8(f) << 16) | (g3d_read_int8(f) << 24);
}

gfloat g3d_read_float_be(FILE *f)
{
	union {
		gfloat f;
		guint8 u[4];
	} u;

	u.u[3] = g3d_read_int8(f);
	u.u[2] = g3d_read_int8(f);
	u.u[1] = g3d_read_int8(f);
	u.u[0] = g3d_read_int8(f);

	return u.f;
}

gfloat g3d_read_float_le(FILE *f)
{
	union {
		gfloat f;
		guint8 u[4];
	} u;

	u.u[0] = g3d_read_int8(f);
	u.u[1] = g3d_read_int8(f);
	u.u[2] = g3d_read_int8(f);
	u.u[3] = g3d_read_int8(f);

	return u.f;
}

